package dev.boyfailure.quajra.vectorbreakout;

import java.util.Timer;
import java.util.TimerTask;

public class Level {
    
    short levelID;
    byte rowHeight = 21;
    String levelName = "LEVEL";
    byte[] levelLayout; // 19 bricks per row
    Brick[] levelBricks;
    
    public Level(int id) {
        this.levelID = (short) id;
        
        switch(id) {
            case 1:
                this.levelName = "HELLO WORLD";
                levelLayout = new byte[]
                {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
                 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,
                 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
                break;
            case 2:
                this.levelName = "DOUBLE TROUBLE";
                levelLayout = new byte[]
                {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
                 3,3,3,3,3,5,3,3,3,3,3,3,3,5,3,3,3,3,3,
                 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
                break;
            case 3:
                this.levelName = "THINKY THINKY...";
                levelLayout = new byte[]
                {4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,
                 3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,
                 2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,
                 1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3};
                break;
            case 4:
                this.levelName = "HOLES!!";
                levelLayout = new byte[]
                {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
                 3,3,0,0,3,3,3,3,0,0,0,3,3,3,3,0,0,3,3,
                 2,2,0,0,2,2,2,2,0,0,0,2,2,2,2,0,0,2,2,
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
                break;
            case 1001:
                this.levelName = "TRANS RIGHTS";
                levelLayout = new byte[]
                {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
                 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
                 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
                 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
                 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
                 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
                 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2};
                break;
            default:
                this.levelName = "LEVEL " + levelID;
                levelLayout = new byte[]
                {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
                break;
        }
        
    }
    
    public void startLevel() {
        // Brick placement
        short brickLeftPlacement = 20;
        if (this.levelLayout != null) {
            this.levelBricks = new Brick[this.levelLayout.length];
            for (int i = 0; i < this.levelLayout.length; i++) {
                switch (this.levelLayout[i]) {
                    case 1:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * this.rowHeight) + 50, false, 3, 4, 0);
                        break;
                    case 2:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * this.rowHeight) + 50, false, 2, 8, 0);
                        break;
                    case 3:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * this.rowHeight) + 50, false, 1, 16, 0);
                        break;
                    case 4:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * this.rowHeight) + 50, false, 0, 32, 0);
                        break;
                    case 5:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * this.rowHeight) + 50, false, 4, 8, 2);
                        break;
                    case 6:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * this.rowHeight) + 50, false, 4, 8, 0);
                        break;
                    case 7:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * this.rowHeight) + 50, false, 15, 8, 0);
                        break;
                    default:
                        this.levelBricks[i] = null;
                        break;
                }
                brickLeftPlacement += 40;
                if (brickLeftPlacement >= 760) {brickLeftPlacement = 20;}
            }
        }
        VectorBreakout.bricksOnScreen = (short) this.levelBricks.length;
        VectorBreakout.currentTextElements[2].setText(String.valueOf(this.levelID));
        VectorBreakout.currentTextElements[3] = new TextElement("", 1, 24, 480, 15, 2);
        VectorBreakout.currentTextElements[3].setText("LEVEL " + String.valueOf(this.levelID) + ": " + this.levelName);
        VectorBreakout.currentTextElements[3].activate();
        Timer levelTitleGTFO = new Timer();
        levelTitleGTFO.schedule(new TimerTask() {
            public void run() {
                VectorBreakout.currentTextElements[3].cull();
            }
        }, 3000);
    }
    
}
